"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWorkContext = exports.args = exports.argParser = void 0;
const argparse_1 = __importDefault(require("argparse"));
const path_1 = __importDefault(require("path"));
const video_1 = require("./video");
exports.argParser = new argparse_1.default.ArgumentParser({
    description: "Subtitle downloader for opensubtitles.net"
});
exports.argParser.add_argument("--lang", "-l", {
    help: "Language to search for",
    dest: "lang",
    default: "eng"
});
exports.argParser.add_argument("--use-name", "-n", {
    help: "Search using movie file name instead of movie file hash (more results, but less accurate)",
    dest: "useName",
    action: "store_true",
    default: false
});
exports.argParser.add_argument("--multi", "-m", {
    help: "Download multiple subtitles",
    dest: "multi",
    action: "store_true",
    default: false
});
exports.argParser.add_argument("--sync", "-s", {
    help: "Automatically sync subtitles to video using alass (alass binary needs to be installed)",
    dest: "sync",
    action: "store_true",
    default: false
});
exports.argParser.add_argument("filename", {
    help: "Movie file to search for subtitles for",
    nargs: "?"
});
exports.args = exports.argParser.parse_args();
function getWorkContext() {
    return __awaiter(this, void 0, void 0, function* () {
        if (exports.args.filename) {
            return {
                workingDir: path_1.default.dirname(exports.args.filename),
                filename: exports.args.filename
            };
        }
        else {
            const filename = yield (0, video_1.selectVideoFileInDir)(process.cwd());
            return {
                workingDir: path_1.default.dirname(filename),
                filename: filename
            };
        }
    });
}
exports.getWorkContext = getWorkContext;
